IMPLEMENTATION MODULE DLineDDA;
  (*/WIN:A*)
  
  IMPORT CStruct,DStruct,MStruct,OStruct;
  IMPORT Windows,WinStart,WLine,WModule;
  IMPORT SYSTEM;
  
  
  VAR
      PlotDungeonLocation : PlotLocationProcedure;
      FirstColumn         : DStruct.DungeonColumnRange;
      FirstLine           : DStruct.DungeonLineRange;
  
  VAR
      TraceProcedureResult : BOOLEAN;
  
  
  PROCEDURE ExecuteDungeonTraceProcedure (player : MStruct.PlayerInfoPointer; line1 : DStruct.DungeonLineRange; column1 : DStruct.DungeonColumnRange; line2 : DStruct.DungeonLineRange; column2 : DStruct.DungeonColumnRange; action : PlotLocationProcedure; VAR result : BOOLEAN);
    VAR
        handler : Windows.LINEDDAPROC;
    
  BEGIN (* ExecuteDungeonTraceProcedure *)
    TraceProcedureResult := result;
    PlotDungeonLocation  := action;
    FirstColumn          := column1;
    FirstLine            := line1;
    handler              := WModule.MakeProcInstance (WinStart.hInstance,SYSTEM.ADR (PlotLineTranslator));
    
    WLine.LineDDA (handler,Windows.LPARAM (player),column1,line1,column2,line2);
    
    result := TraceProcedureResult;
    
    WModule.FreeProcInstance (handler);
  END ExecuteDungeonTraceProcedure;
  
  PROCEDURE PlotLineTranslator ['PLOTLINETRANSLATOR'] (x,y : INTEGER; data : SYSTEM.ADDRESS) [WINDOWS,LONG];
  BEGIN (* PlotLineTranslator *)
    IF ((x <> FirstColumn) OR (y <> FirstLine)) THEN
      PlotDungeonLocation (MStruct.PlayerInfoPointer (data),y,x,TraceProcedureResult);
    END; (* IF *)
  END PlotLineTranslator;
END DLineDDA.
