IMPLEMENTATION MODULE MCommStr;
  (*/WIN:A*)
  
  IMPORT WDebugging;
  IMPORT MCommands;
  IMPORT Strings;
  
  
  PROCEDURE CommandMnemonicToString (command : MCommands.MoriaCommandMnemonic; VAR result : ARRAY OF CHAR);
  BEGIN (* CommandMnemonicToString *)
    CASE command OF
      MCommands.AscendStairs         : Strings.Assign ("Ascend",result); |
      MCommands.Bash                 : Strings.Assign ("Bash",result); |
      MCommands.BrowseBook           : Strings.Assign ("Browse",result); |
      MCommands.CastMagicSpell       : Strings.Assign ("Magic Spell",result); |
      MCommands.CharacterInformation : Strings.Assign ("Character Info",result); |
      MCommands.CloseObject          : Strings.Assign ("Close",result); |
      MCommands.DescendStairs        : Strings.Assign ("Descend",result); |
      MCommands.DisarmTrap           : Strings.Assign ("Disarm",result); |
      MCommands.DropObject           : Strings.Assign ("Drop",result); |
      MCommands.Eat                  : Strings.Assign ("Eat",result); |
      MCommands.ExchangeWeapons      : Strings.Assign ("Exchange Weapons",result); |
      MCommands.Exit                 : Strings.Assign ("Exit",result); |
      MCommands.FillLamp             : Strings.Assign ("Fill Lamp",result); |
      MCommands.InscribeObject       : Strings.Assign ("Inscribe",result); |
      MCommands.InventoryCommands    : Strings.Assign ("Inventory",result); |
      MCommands.LearnSpells          : Strings.Assign ("Learn Spells",result); |
      MCommands.Look                 : Strings.Assign ("Look",result); |
      MCommands.MoveAtRun            : Strings.Assign ("Move In Direction",result); |
      MCommands.MoveToLocation       : Strings.Assign ("Move To Location",result); |
      MCommands.OpenObject           : Strings.Assign ("Open",result); |
      MCommands.Options              : Strings.Assign ("Options",result); |
      MCommands.QuaffPotion          : Strings.Assign ("Quaff",result); |
      MCommands.Quit                 : Strings.Assign ("Quit",result); |
      MCommands.ReadHolyPrayer       : Strings.Assign ("Holy Prayer",result); |
      MCommands.ReadScroll           : Strings.Assign ("Read Scroll",result); |
      MCommands.RestMultipleTurns    : Strings.Assign ("Rest",result); |
      MCommands.RestOneTurn          : Strings.Assign ("Stand Still",result); |
      MCommands.SearchLocation       : Strings.Assign ("Search Location",result); |
      MCommands.SearchToggle         : Strings.Assign ("Search Toggle",result); |
      MCommands.SpikeDoor            : Strings.Assign ("Spike",result); |
      MCommands.ThrowObject          : Strings.Assign ("Throw/Fire",result); |
      MCommands.Tunnel               : Strings.Assign ("Tunnel",result); |
      MCommands.UseStaff             : Strings.Assign ("Use Staff",result); |
      MCommands.UseWand              : Strings.Assign ("Aim Wand",result); |
      MCommands.ViewScores           : Strings.Assign ("View Scores",result); |
    ELSE
      WDebugging.FatalAppExit ("Invalid attempt to convert command mnemonic to string.");
    END; (* CASE *)
  END CommandMnemonicToString;
END MCommStr.
