IMPLEMENTATION MODULE MCSActs2;
  (*/WIN:A*)
  
  IMPORT MCStruct;
  IMPORT Strings;
  IMPORT WString;
  
  
  PROCEDURE ReturnClassMnemonicString (class : MCStruct.PlayerClassMnemonic; VAR result : ARRAY OF CHAR);
  BEGIN (* ReturnClassMnemonicString *)
    CASE class OF
      MCStruct.Warrior : Strings.Assign ("Warrior",result); |
      MCStruct.Mage    : Strings.Assign ("Mage",result);    |
      MCStruct.Priest  : Strings.Assign ("Priest",result);  |
      MCStruct.Rogue   : Strings.Assign ("Rogue",result);   |
      MCStruct.Ranger  : Strings.Assign ("Ranger",result);  |
      MCStruct.Paladin : Strings.Assign ("Paladin",result); |
    END; (* CASE *)
  END ReturnClassMnemonicString;
  
  PROCEDURE ReturnRaceMnemonicString (race : MCStruct.PlayerRaceMnemonic; VAR result : ARRAY OF CHAR);
  BEGIN (* ReturnRaceMnemonicString *)
    CASE race OF
      MCStruct.Human     : Strings.Assign ("Human",result);      |
      MCStruct.HalfElf   : Strings.Assign ("Half-Elf",result);   |
      MCStruct.Elf       : Strings.Assign ("Elf",result);        |
      MCStruct.Halfling  : Strings.Assign ("Halfling",result);   |
      MCStruct.Gnome     : Strings.Assign ("Gnome",result);      |
      MCStruct.Dwarf     : Strings.Assign ("Dwarf",result);      |
      MCStruct.HalfOrc   : Strings.Assign ("Half-Orc",result);   |
      MCStruct.HalfTroll : Strings.Assign ("Half-Troll",result); |
    END; (* CASE *)
  END ReturnRaceMnemonicString;
  
  PROCEDURE ReturnSexMnemonicString (sex : MCStruct.PlayerSexMnemonic; VAR result : ARRAY OF CHAR);
  BEGIN (* ReturnSexMnemonicString *)
    CASE sex OF
      MCStruct.Male   : Strings.Assign ("Male",result);   |
      MCStruct.Female : Strings.Assign ("Female",result); |
    END; (* CASE *)
  END ReturnSexMnemonicString;

  PROCEDURE StatisticRangeToString (value : MCStruct.PlayerStatisticRange; VAR result : ARRAY OF CHAR);
  BEGIN (* StatisticRangeToString *)
    CASE value OF
      3..18   : WString.ReplaceCardinalParameter ("%VALUE","%VALUE",value,result);          |
      19..117 : WString.ReplaceCardinalParameter ("18/0%VALUE","%VALUE",value - 18,result); |
      118     : Strings.Assign ("18/100",result);                                           |
    END; (* CASE *)
  END StatisticRangeToString;
END MCSActs2.
