IMPLEMENTATION MODULE MRandom;
  (*/WIN:A*)

  IMPORT Random;
  
  
  PROCEDURE CardinalRandomRangeValue (min,max : CARDINAL) : CARDINAL;
  BEGIN (* CardinalRandomRangeValue *)
    RETURN (min + Random.RandomCard (max - min + 1));
  END CardinalRandomRangeValue;
  
  PROCEDURE IntegerRandomRangeValue (min,max : CARDINAL) : INTEGER;
  BEGIN (* IntegerRandomRangeValue *)
    RETURN (min + Random.RandomCard (max - min + 1));
  END IntegerRandomRangeValue;
  
  PROCEDURE Randomize;
  BEGIN (* Randomize *)
    Random.Randomize;
  END Randomize;
  
  PROCEDURE RandomNormalValue (mean,deviation : INTEGER) : INTEGER;
  BEGIN (* RandomNormalValue *)
    RETURN (mean + (IntegerRandomRangeValue (8,792) - 400) * deviation DIV 81);
  END RandomNormalValue;
  
  PROCEDURE RandomRealValue () : REAL;
  BEGIN (* RandomRealValue *)
    RETURN (Random.RandomReal ());
  END RandomRealValue;
  
  PROCEDURE RandomSeedValue () : CARDINAL;
  BEGIN (* RandomSeedValue *)
    RETURN (Random.RandomCard (0));
  END RandomSeedValue;
  
  PROCEDURE SetRandomSeed (seed : CARDINAL);
  BEGIN (* SetRandomSeed *)
    Random.RandomInit (seed);
  END SetRandomSeed;
END MRandom.
