IMPLEMENTATION MODULE MSHaggle;
  (*/WIN:A*)
  
  IMPORT MDialogs,MMWindow,MStores,MStores7;
  IMPORT WDialog,WDisplay,Windows;
  IMPORT Strings,SYSTEM;
  
  
  PROCEDURE ExecuteHaggleDialog (window : Windows.HWND; info : MStores.StoreDialogInfoPointer; InitializeDialog : MDialogs.MoriaParamDialogInitializationProcedure; ExecuteDialogCommand : MDialogs.MoriaParamDialogCommandProcedure; CloseDialog : MDialogs.MoriaParamDialogCloseProcedure; VAR price : LONGINT; VAR accepted : BOOLEAN);
    VAR
        haggle : StoreHaggleInformation;
        result : INTEGER;
    
  BEGIN (* ExecuteHaggleDialog *)
    haggle.info := info;
    
    MDialogs.ExecuteMoriaDialogBoxParam (window,"Haggle_Dialog",info^.player,SYSTEM.ADR (haggle),InitializeDialog,ExecuteDialogCommand,CloseDialog,result);
    
    accepted := (result = Windows.TRUE_BOOL);
    price    := info^.price;
  END ExecuteHaggleDialog;
  
  PROCEDURE InitializeHaggleTitle (window : Windows.HWND; owner : ARRAY OF CHAR);
  BEGIN (* InitializeHaggleTitle *)
    MMWindow.ReturnStoreOwnerName (owner,owner);
    Strings.Insert ("Haggling with ",owner,0);
    
    WDisplay.SetWindowText (window,owner);
  END InitializeHaggleTitle;
  
  PROCEDURE UpdateFinalAskingInformation (window : Windows.HWND; VAR haggle : StoreHaggleInformation);
  BEGIN (* UpdateFinalAskingInformation *)
    IF haggle.finalCOUNT = 0 THEN
      WDialog.SetDlgItemText (window,AskingPricePromptStaticTextControl,"Final offer:");
    END; (* IF *)
    
    haggle.finalCOUNT := haggle.finalCOUNT + 1;
    haggle.currentASK := haggle.finalASK;
    
    IF haggle.finalCOUNT > MaxFinalOffers THEN
      MStores7.IncreaseStoreInsults (window,haggle.info^.player,haggle.info^.store^,haggle.info^.ejected);
    END; (* IF *)
  END UpdateFinalAskingInformation;
END MSHaggle.
