IMPLEMENTATION MODULE WDebugging;
  (*/WIN:A*)
  
  IMPORT Strings,SYSTEM,Win31,Windows;
  (*
  IMPORT MEDW;
  *)
  
  PROCEDURE DebugBreak;
  BEGIN (* DebugBreak *)
    Windows.DebugBreak;
  END DebugBreak;
  
  PROCEDURE DirectedYield (task : Windows.HTASK);
  BEGIN (* DirectedYield *)
    Windows.DirectedYield (task);
  END DirectedYield;
  
  PROCEDURE FatalAppExit (message : ARRAY OF CHAR);
  BEGIN (* FatalAppExit *)
    Windows.FatalAppExit (Windows.NULL,SYSTEM.ADR (message));
  END FatalAppExit;
  
  PROCEDURE FatalExit (code : INTEGER);
  BEGIN (* FatalExit *)
    Windows.FatalExit (code);
  END FatalExit;
  
  PROCEDURE OutputDebugString (text : ARRAY OF CHAR);
  BEGIN (* OutputDebugString *)
    Windows.OutputDebugString (SYSTEM.ADR (text));
  END OutputDebugString;
  
  PROCEDURE ValidateCodeSegments;
  BEGIN (* ValidateCodeSegments *)
    Windows.ValidateCodeSegments;
  END ValidateCodeSegments;
  
  PROCEDURE ValidateFreeSpaces;
  BEGIN (* ValidateFreeSpaces *)
    Windows.ValidateFreeSpaces;
  END ValidateFreeSpaces;
  
  
  PROCEDURE CallingError (module,procedure : ARRAY OF CHAR);
    VAR
        message : ARRAY [0..255] OF CHAR;
    
  BEGIN (* CallingError *)
    Strings.Concat ("Call to ===> ",module,message);
    Strings.Concat (message,".",message);
    Strings.Concat (message,procedure,message);
    
    FatalAppExit (message);
  END CallingError;
END WDebugging.
