IMPLEMENTATION MODULE MGenocide;
  (*/WIN:A*)
  
  IMPORT WDialog,WDisplay,Windows,WListBox;
  
  IMPORT MDialogs,MWSummon;
  IMPORT CStruct,MStruct;
  
  
  PROCEDURE CloseGenocideDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseGenocideDialog *)
    WDialog.EndDialog (window,0);
  END CloseGenocideDialog;
  
  PROCEDURE ExecuteGenocideDialogCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    PROCEDURE ExecuteCancelAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCancelAction *)
      IF command = Windows.BN_CLICKED THEN
        CloseGenocideDialog (window,player);
      END; (* IF *)
    END ExecuteCancelAction;
    
    PROCEDURE ExecuteCreatureListAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
    BEGIN (* ExecuteCreatureListAction *)
      IF command = Windows.LBN_SELCHANGE THEN
        WDialog.EnableDialogControl (window,MWSummon.SummonPushButtonControl,TRUE);
      ELSIF command = Windows.LBN_DBLCLK THEN
        ExecuteExterminateAction (window,player,Windows.BN_CLICKED);
      END; (* IF *)
    END ExecuteCreatureListAction;
    
    PROCEDURE ExecuteExterminateAction (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
      PROCEDURE SymbolForSelectedCreature (creatures : CStruct.CreatureInfoPointer; control : Windows.HWND) : INTEGER;
      BEGIN (* SymbolForSelectedCreature *)
        RETURN (ORD (creatures^.table [WListBox.GetCurSel (control)].symbol));
      END SymbolForSelectedCreature;
      
    BEGIN (* ExecuteExterminateAction *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.EndDialog (window,SymbolForSelectedCreature (player^.creatures,WDialog.GetDlgItem (window,MWSummon.CreatureListBoxControl)));
      END; (* IF *)
    END ExecuteExterminateAction;
    
  BEGIN (* ExecuteGenocideDialogCommand *)
    CASE control OF
      MWSummon.SummonPushButtonControl : ExecuteExterminateAction (window,player,command); |
      MWSummon.CancelPushButtonControl : ExecuteCancelAction (window,player,command);      |
      
      MWSummon.CreatureListBoxControl : ExecuteCreatureListAction (window,player,command); |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteGenocideDialogCommand;
  
  PROCEDURE ExecuteGenocideSelectDialog (player : MStruct.PlayerInfoPointer; VAR result : CHAR; VAR done : BOOLEAN);
    VAR
        value : INTEGER;
    
  BEGIN (* ExecuteGenocideSelectDialog *)
    MDialogs.ExecuteMoriaDialogBox (player^.windows.frame,"Wizard_Summon_Dialog",player,InitializeGenocideDialog,ExecuteGenocideDialogCommand,CloseGenocideDialog,value);
    
    result := CHR (value);
    done   := result <> 0C;
  END ExecuteGenocideSelectDialog;
  
  PROCEDURE InitializeGenocideDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeGenocideDialog *)
    WDisplay.SetWindowText (window,"Exterminate Creatures");
    
    WDialog.SetDlgItemText (window,MWSummon.SummonPushButtonControl,"E&xterminate");
    
    WDialog.ShowDialogControl (window,MWSummon.RandomPushButtonControl,FALSE);
    WDialog.ShowDialogControl (window,MWSummon.AsleepCheckBoxControl,FALSE);
    
    MWSummon.InitializeWizardSummonDialog (window,player);
  END InitializeGenocideDialog;
END MGenocide.
