IMPLEMENTATION MODULE MKeys;
  (*/WIN:A*)
  
  IMPORT WDebugging,Windows;
  
  
  PROCEDURE CharForKeyDownValue (value : CARDINAL) : CHAR;
  BEGIN (* CharForKeyDownValue *)
    CASE value OF
      Windows.VK_PRIOR : RETURN ('9'); |
      Windows.VK_NEXT  : RETURN ('3'); |
      Windows.VK_END   : RETURN ('1'); |
      Windows.VK_HOME  : RETURN ('7'); |
      Windows.VK_LEFT  : RETURN ('4'); |
      Windows.VK_UP    : RETURN ('8'); |
      Windows.VK_RIGHT : RETURN ('6'); |
      Windows.VK_DOWN  : RETURN ('2'); |
    ELSE
      WDebugging.FatalAppExit ("Invalid virtual character.");
    END; (* CASE *)
  END CharForKeyDownValue;
  
  PROCEDURE DirectionForCharacter (value : CARDINAL) : CARDINAL;
  BEGIN (* DirectionForCharacter *)
    IF ((value >= Windows.VK_PRIOR) AND (value <= Windows.VK_DOWN)) THEN
      CASE value OF
        Windows.VK_PRIOR : RETURN (9); |
        Windows.VK_NEXT  : RETURN (3); |
        Windows.VK_END   : RETURN (1); |
        Windows.VK_HOME  : RETURN (7); |
        Windows.VK_LEFT  : RETURN (4); |
        Windows.VK_UP    : RETURN (8); |
        Windows.VK_RIGHT : RETURN (6); |
        Windows.VK_DOWN  : RETURN (2); |
      END; (* CASE *)
    ELSE
      CASE value OF
        ORD ('1') :  RETURN (1); |
        ORD ('2') :  RETURN (2); |
        ORD ('3') :  RETURN (3); |
        ORD ('4') :  RETURN (4); |
        ORD ('6') :  RETURN (6); |
        ORD ('7') :  RETURN (7); |
        ORD ('8') :  RETURN (8); |
        ORD ('9') :  RETURN (9); |
      END; (* CASE *)
    END; (* IF *)
  END DirectionForCharacter;
  
  PROCEDURE ValidDirectionCharacter (value : CARDINAL) : BOOLEAN;
  BEGIN (* ValidDirectionCharacter *)
    RETURN (((value >= Windows.VK_PRIOR) AND (value <= Windows.VK_DOWN)) OR ((value >= ORD ('1')) AND (value <= ORD ('9')) AND (value <> ORD ('5'))));
  END ValidDirectionCharacter;

  PROCEDURE ValidKeyDownValue (value : CARDINAL) : BOOLEAN;
  BEGIN (* ValidKeyDownValue *)
    RETURN ((value >= Windows.VK_PRIOR) AND (value <= Windows.VK_DOWN));
  END ValidKeyDownValue;
END MKeys.
