IMPLEMENTATION MODULE MMouse2;
  (*/WIN:A*)
  
  IMPORT MCommands,MCommStr,MMouse;
  IMPORT Windows,WListBox,WString;
  IMPORT ASCII;
  
  
  PROCEDURE AddMoriaCommandMnemonic (control : Windows.HWND; command : MCommands.MoriaCommandMnemonic);
    VAR
        result : Windows.LRESULT;
        text   : ARRAY [0..31] OF CHAR;
    
  BEGIN (* AddMoriaCommandMnemonic *)
    MCommStr.CommandMnemonicToString (command,text);
    WListBox.AddStringAndData (control,text,ORD (command),result);
  END AddMoriaCommandMnemonic;
  
  PROCEDURE InsertMouseAction (control : Windows.HWND; position : CARDINAL; button : MMouse.MouseButtonMnemonic; shift : MMouse.ShiftKeyMnemonic; command : MCommands.MoriaCommandMnemonic);
    VAR
        result : Windows.LRESULT;
        text   : ARRAY [0..63] OF CHAR;
    
  BEGIN (* InsertMouseAction *)
    WString.ReplaceCharParameter ("%SHIFT %BUTTON:|%COMMAND","|",ASCII.ht,text);
    
    CASE shift OF
      MMouse.ControlShift : WString.ReplaceStringParameter (text,"%SHIFT","Ctrl-Shift",text); |
      MMouse.ControlKey   : WString.ReplaceStringParameter (text,"%SHIFT","Ctrl",text);       |
      MMouse.NotShifted   : WString.ReplaceStringParameter (text,"%SHIFT ","",text);          |
      MMouse.ShiftKey     : WString.ReplaceStringParameter (text,"%SHIFT","Shift",text);      |
    END; (* CASE *)
    
    ReplaceMoriaCommandMnemonic (text,"%COMMAND",command,text);
    
    IF button = MMouse.RightButton THEN
      WString.ReplaceStringParameter (text,"%BUTTON","Right",text);
    ELSE
      WString.ReplaceStringParameter (text,"%BUTTON","Left",text);
    END; (* IF *)
    
    WListBox.InsertString (control,position,text,result);
  END InsertMouseAction;
  
  PROCEDURE ReplaceMoriaCommandMnemonic (str : ARRAY OF CHAR; formal : ARRAY OF CHAR; command : MCommands.MoriaCommandMnemonic; VAR result : ARRAY OF CHAR);
    VAR
        actual : ARRAY [0..31] OF CHAR;
    
  BEGIN (* ReplaceMoriaCommandMnemonic *)
    MCommStr.CommandMnemonicToString (command,actual);
    WString.ReplaceStringParameter (str,formal,actual,result);
  END ReplaceMoriaCommandMnemonic;
END MMouse2.
