IMPLEMENTATION MODULE MPComm2;
  (*/WIN:A*)
  
  IMPORT Windows;
  
  IMPORT MCDialog,MInitFile,MInventory,MMenu,MMTranslator,MMWindow,MPComm1,MPInven4;
  IMPORT MCStruct,MStruct,OStruct;
  
  
  PROCEDURE ExecuteCharacterInformationCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteCharacterInformationCommand *)
    MCDialog.DisplayCharacterInformation (player^.windows.frame,player);
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteCharacterInformationCommand;
  
  PROCEDURE ExecuteExchangeWeaponsCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteExchangeWeaponsCommand *)
    MStruct.CharacterTurnExecuted := ((player^.character^.inventory.equipment [MCStruct.Weapon1].object.class <> OStruct.Nothing) OR (player^.character^.inventory.equipment [MCStruct.Weapon2].object.class <> OStruct.Nothing));
    
    IF MStruct.CharacterTurnExecuted THEN
      MPInven4.ExchangePlayerWeapons (player^.windows.frame,player,FALSE);
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"But you are wielding no weapons.");
    END; (* IF *)
  END ExecuteExchangeWeaponsCommand;
  
  PROCEDURE ExecuteSpikeDoorCommand (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteSpikeDoorCommand *)
    IF MInventory.AnyObjectsWithClasses (player^.character^.inventory.backpack,OStruct.ObjectClassSet {OStruct.Spike}) THEN
      MMTranslator.ExecuteDirectedCommand (player,"Spike door in which direction?",MPComm1.ExecuteSpikeAction);
    ELSE
      MMWindow.DisplayPopupMessage (player^.windows.frame,player,"But you have no spikes.");
      MStruct.CharacterTurnExecuted := FALSE;
    END; (* IF *)
  END ExecuteSpikeDoorCommand;
  
  PROCEDURE ExecuteStartMaximizedToggle (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteStartMaximizedToggle *)
    IF MInitFile.StartupDisplayOption () = Windows.SW_SHOWMAXIMIZED THEN
      MInitFile.SetStartupDisplayOption (Windows.SW_SHOWNORMAL);
      MMenu.SetMaximizedMarker (MStruct.CurrentPlayerFrameWindow,FALSE);
    ELSE
      MInitFile.SetStartupDisplayOption (Windows.SW_SHOWMAXIMIZED);
      MMenu.SetMaximizedMarker (MStruct.CurrentPlayerFrameWindow,TRUE);
    END; (* IF *)
    
    MStruct.CharacterTurnExecuted := FALSE;
  END ExecuteStartMaximizedToggle;
END MPComm2.
