IMPLEMENTATION MODULE MPInven2;
  (*/WIN:A*)
  
  IMPORT MPInventory,MPInven3,ODescriptions;
  IMPORT WDialog,Windows,WListBox;
  IMPORT MStruct,OStruct;
  
  
  PROCEDURE ExecuteBackpackListCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; command : CARDINAL);
  BEGIN (* ExecuteBackpackListCommand *)
    IF command = Windows.LBN_SELCHANGE THEN
      WDialog.EnableDialogControl (window,MPInventory.WearWieldPushButtonControl,TRUE);
      WDialog.EnableDialogControl (window,MPInventory.DropPushButtonControl,TRUE);
    ELSIF command = Windows.LBN_DBLCLK THEN
      MPInven3.ExecuteWearWieldButtonCommand (window,player,Windows.BN_CLICKED);
    END; (* IF *)
  END ExecuteBackpackListCommand;
  
  PROCEDURE InitializeBackpackListBox (control : Windows.HWND; player : MStruct.PlayerInfoPointer; classes : OStruct.ObjectClassSet);
    VAR
        index : CARDINAL;
    
    PROCEDURE AddObjectToBackpackListBox (control : Windows.HWND; player : MStruct.PlayerInfoPointer; item : OStruct.InventoryItemRecord; position : CARDINAL);
      VAR
          result : Windows.LRESULT;
          text   : ARRAY [0..127] OF CHAR;
      
    BEGIN (* AddObjectToBackpackListBox *)
      ODescriptions.ReturnObjectDescription (player,item,TRUE,text);
      WListBox.AddStringAndData (control,text,position,result);
    END AddObjectToBackpackListBox;
    
  BEGIN (* InitializeBackpackListBox *)
    WListBox.SetRedraw (control,FALSE);
    
    WListBox.SetHorizontalExtent (control,1024);
    WListBox.ResetContent (control);
    
    index := 0;
    
    WHILE index < player^.character^.inventory.counter DO
      IF player^.character^.inventory.backpack [index].object.class IN classes THEN
        AddObjectToBackpackListBox (control,player,player^.character^.inventory.backpack [index],index);
      END; (* IF *)
      
      INC (index);
    END; (* WHILE *)
    
    WListBox.SetRedraw (control,TRUE);
  END InitializeBackpackListBox;
END MPInven2.
