IMPLEMENTATION MODULE MPInven7;
  (*/WIN:A*)
  
  IMPORT WDialog,Windows;
  IMPORT SYSTEM;
  
  IMPORT MCStruct,MStruct,OStruct;
  IMPORT MDialogs,ODescriptions;
  
  
  CONST
        RightHandPushButton = 303;
        LeftHandPushButton  = 302;
        CancelPushButton    = 304;
  
  CONST
        InvalidRingPosition = -1;
  
  
  PROCEDURE CloseWearRingDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
  BEGIN (* CloseWearRingDialog *)
    ExecuteWearRingCommand (window,player,NIL,CancelPushButton,Windows.BN_CLICKED);
  END CloseWearRingDialog;
  
  PROCEDURE DetermineRingPosition (window : Windows.HWND; player : MStruct.PlayerInfoPointer; ring : OStruct.InventoryItemRecord; VAR position : MCStruct.PlayerEquipmentMnemonic; VAR done : BOOLEAN);
    VAR
        result : INTEGER;
    
  BEGIN (* DetermineRingPosition *)
    MDialogs.ExecuteMoriaDialogBoxParam (window,"Wear_Ring_Dialog",player,SYSTEM.ADR (ring),InitializeWearRingDialog,ExecuteWearRingCommand,CloseWearRingDialog,result);
    done := (result <> InvalidRingPosition);
    
    IF done THEN
      position := VAL (MCStruct.PlayerEquipmentMnemonic,result);
    END; (* IF *)
  END DetermineRingPosition;
  
  PROCEDURE ExecuteWearRingCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS; control : CARDINAL; command : CARDINAL);
  BEGIN (* ExecuteWearRingCommand *)
    IF command = Windows.BN_CLICKED THEN
      CASE control OF
        RightHandPushButton : WDialog.EndDialog (window,ORD (MCStruct.RingRight)); |
        LeftHandPushButton  : WDialog.EndDialog (window,ORD (MCStruct.RingLeft));  |
        
        CancelPushButton,Windows.IDCANCEL : WDialog.EndDialog (window,InvalidRingPosition); |
        
        Windows.IDOK : (* no action *)
      END; (* CASE *)
    END; (* CASE *)
  END ExecuteWearRingCommand;
  
  PROCEDURE InitializeWearRingDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer; data : SYSTEM.ADDRESS);
    TYPE
         InventoryItemPointer = POINTER TO OStruct.InventoryItemRecord;
    
    VAR
        text : ARRAY [0..255] OF CHAR;
    
    PROCEDURE DetermineHandQueryText (player : MStruct.PlayerInfoPointer; item : InventoryItemPointer; VAR result : ARRAY OF CHAR);
    BEGIN (* DetermineHandQueryText *)
      ODescriptions.ReplaceObjectDescription ("Put %OBJECT on which hand?","%OBJECT",player,item^,FALSE,result);
    END DetermineHandQueryText;
    
  BEGIN (* InitializeWearRingDialog *)
    DetermineHandQueryText (player,InventoryItemPointer (data),text);
    WDialog.SetDlgItemText (window,301,text);
  END InitializeWearRingDialog;
END MPInven7.
