IMPLEMENTATION MODULE MPray2;
  (*/WIN:A*)
  
  IMPORT MBalls,MBolts,MCSpells,MCSpell3,MCSpell4,MMTranslator,MRandom;
  IMPORT DStruct,MStruct;
  
  
  PROCEDURE ExecuteBlindCreatureAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteBlindCreatureAction *)
    MBolts.TraceMagicBoltPath (player,line,column,MCSpell3.ExecuteConfusionDamage,done);
    MCSpells.DecreasePlayerMana (player,8,TRUE);
  END ExecuteBlindCreatureAction;
  
  PROCEDURE ExecuteBlindCreaturePrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteBlindCreaturePrayer *)
    MMTranslator.ExecuteTargetedCommand (player,"Blind which creature?",ExecuteBlindCreatureAction);
  END ExecuteBlindCreaturePrayer;

  PROCEDURE ExecuteOrbOfDrainingAction (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange);
    VAR
        done : BOOLEAN;
    
  BEGIN (* ExecuteOrbOfDrainingAction *)
    MBolts.TraceMagicBoltPath (player,line,column,ExecuteOrbOfDrainingDamage,done);
    MCSpells.DecreasePlayerMana (player,17,TRUE);
  END ExecuteOrbOfDrainingAction;
  
  PROCEDURE ExecuteOrbOfDrainingDamage (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* ExecuteOrbOfDrainingDamage *)
    MCSpell4.ExecutePlayerMagicBallDamage (player,line,column,MRandom.IntegerRandomRangeValue (3,18) + player^.character^.variables.level,MBalls.ExecuteOrbOfDrainingDamage,"Collateral Damage from Orb of Draining","Black Sphere");
    done := TRUE;
  END ExecuteOrbOfDrainingDamage;

  PROCEDURE ExecuteOrbOfDrainingPrayer (player : MStruct.PlayerInfoPointer);
  BEGIN (* ExecuteOrbOfDrainingPrayer *)
    MMTranslator.ExecuteTargetedCommand (player,"Target for Orb of Draining?",ExecuteOrbOfDrainingAction);
  END ExecuteOrbOfDrainingPrayer;
END MPray2.
