IMPLEMENTATION MODULE MSight;
  (*/WIN:A*)
  
  IMPORT DStruct,MStruct;
  IMPORT DLineDDA;
  
  
  CONST
        VisionBlockingElements = DStruct.DungeonWallElements + DStruct.DungeonElementSet {DStruct.BlockedFloor};
  
  
  PROCEDURE CheckLineOfSightLocation (player : MStruct.PlayerInfoPointer; line : DStruct.DungeonLineRange; column : DStruct.DungeonColumnRange; VAR done : BOOLEAN);
  BEGIN (* CheckLineOfSightLocation *)
    done := (done AND (player^.dungeon^.physical [line]^ [column].elements * VisionBlockingElements = DStruct.EmptyDungeonElementSet));
  END CheckLineOfSightLocation;
  
  PROCEDURE ClearLineOfSight (player : MStruct.PlayerInfoPointer; line1 : DStruct.DungeonLineRange; column1 : DStruct.DungeonColumnRange; line2 : DStruct.DungeonLineRange; column2 : DStruct.DungeonColumnRange) : BOOLEAN;
    VAR
        done : BOOLEAN;
    
  BEGIN (* ClearLineOfSight *)
    IF ((ABS (line1 - line2) < 2) AND (ABS (column1 - column2) < 2)) THEN
      RETURN (TRUE);
    END; (* IF *)
    
    done := TRUE;
    
    DLineDDA.ExecuteDungeonTraceProcedure (player,line1,column1,line2,column2,CheckLineOfSightLocation,done);
    
    RETURN (done);
  END ClearLineOfSight;
END MSight.
