IMPLEMENTATION MODULE MSText;
  (*/WIN:A*)
  
  IMPORT WDisplay,WString;
  
  IMPORT MCStruct,MStruct;
  IMPORT MCSActs2;
  
  
  PROCEDURE SetStatusControlCardinal (player : MStruct.PlayerInfoPointer; line,column : CARDINAL; str : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : CARDINAL; color : MStruct.StatusControlColorMnemonic);
    VAR
        text : ARRAY [0..127] OF CHAR;
    
  BEGIN (* SetStatusControlCardinal *)
    WString.ReplaceCardinalParameter (str,formal,actual,text);
    SetStatusControlText (player,line,column,text,color);
  END SetStatusControlCardinal;
  
  PROCEDURE SetStatusControlInteger (player : MStruct.PlayerInfoPointer; line,column : CARDINAL; str : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : INTEGER; color : MStruct.StatusControlColorMnemonic);
    VAR
        text : ARRAY [0..127] OF CHAR;
    
  BEGIN (* SetStatusControlInteger *)
    WString.ReplaceIntegerParameter (str,formal,actual,text);
    SetStatusControlText (player,line,column,text,color);
  END SetStatusControlInteger;
  
  PROCEDURE SetStatusControlLongInt (player : MStruct.PlayerInfoPointer; line,column : CARDINAL; str : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : LONGINT; color : MStruct.StatusControlColorMnemonic);
    VAR
        text : ARRAY [0..127] OF CHAR;
    
  BEGIN (* SetStatusControlLongInt *)
    WString.ReplaceLongIntParameter (str,formal,actual,text);
    SetStatusControlText (player,line,column,text,color);
  END SetStatusControlLongInt;
  
  PROCEDURE SetStatusControlStatistic (player : MStruct.PlayerInfoPointer; line,column : CARDINAL; str : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : MCStruct.PlayerStatisticRange; color : MStruct.StatusControlColorMnemonic);
    VAR
        text : ARRAY [0..127] OF CHAR;
    
    PROCEDURE ReplaceStatisticParameter (str : ARRAY OF CHAR; formal : ARRAY OF CHAR; actual : MCStruct.PlayerStatisticRange; VAR result : ARRAY OF CHAR);
      VAR
          temp : ARRAY [0..15] OF CHAR;
      
    BEGIN (* ReplaceStatisticParameter *)
      MCSActs2.StatisticRangeToString (actual,temp);
      WString.ReplaceStringParameter (str,formal,temp,result);
    END ReplaceStatisticParameter;
    
  BEGIN (* SetStatusControlStatistic *)
    ReplaceStatisticParameter (str,formal,actual,text);
    SetStatusControlText (player,line,column,text,color);
  END SetStatusControlStatistic;
  
  PROCEDURE SetStatusControlText (player : MStruct.PlayerInfoPointer; line,column : CARDINAL; text : ARRAY OF CHAR; color : MStruct.StatusControlColorMnemonic);
  BEGIN (* SetStatusControlText *)
    player^.windows.status.table [line,column].color := color;
    WDisplay.SetWindowText (player^.windows.status.table [line,column].handle,text);
  END SetStatusControlText;
END MSText.
