IMPLEMENTATION MODULE MStores8;
  (*/WIN:A*)
  
  IMPORT WDialog,WEditText,Windows,WString;
  IMPORT MMWindow,MSHaggle,MStores7;
  
  
  PROCEDURE DetermineNewPlayerOffer (window : Windows.HWND; control : CARDINAL; VAR haggle : MSHaggle.StoreHaggleInformation; factor : LONGINT; VAR offer : LONGINT; VAR done : BOOLEAN);
    PROCEDURE DetermineOfferAmount (window : Windows.HWND; control : CARDINAL; VAR haggle : MSHaggle.StoreHaggleInformation; VAR offer : LONGINT; VAR done : BOOLEAN);
      PROCEDURE ShouldIncrementPlayerOffer (window : Windows.HWND; control : CARDINAL) : BOOLEAN;
        VAR
            length : CARDINAL;
            text   : ARRAY [0..127] OF CHAR;
        
      BEGIN (* ShouldIncrementPlayerOffer *)
        WDialog.GetDlgItemText (window,control,text,length);
        WString.RemoveInitialWhiteSpace (text);
        
        RETURN ((text [0] = '+') OR (text [0] = '-'));
      END ShouldIncrementPlayerOffer;
      
    BEGIN (* DetermineOfferAmount *)
      WDialog.GetDlgItemLongInt (window,control,offer,done);
      
      IF (done AND ShouldIncrementPlayerOffer (window,control)) THEN
        IF haggle.offerCOUNT > 0 THEN
          offer := haggle.prevOFFER + offer;
        ELSE
          MMWindow.DisplayStoreMessage (window,haggle.info^.player,haggle.info^.store^.owner.description,"You haven't even made your first offer yet!");
          done := FALSE;
        END; (* IF *)
      END; (* IF *)
      
      WEditText.HighlightEditTextControl (window,control);
    END DetermineOfferAmount;
    
  BEGIN (* DetermineNewPlayerOffer *)
    DetermineOfferAmount (window,control,haggle,offer,done);
    
    IF (done AND (offer * factor < haggle.prevOFFER * factor)) THEN
      MStores7.ExecuteInsultingOfferAction (window,haggle.info^.player,haggle.info^.store^,haggle.info^.ejected);
    END; (* IF *)
  END DetermineNewPlayerOffer;
END MStores8.
