IMPLEMENTATION MODULE MWClasses;
  (*/WIN:A*)
  
  IMPORT WCreation,WCursor,WDTool,Windows,WResource;
  IMPORT MDWindow,MMTranslator,MMWindow,MSWindow;
  IMPORT MStruct;
  IMPORT SYSTEM;
  
  
  VAR
      DungeonWindowClassData : Windows.WNDCLASS;
      DungeonWindowClassAtom : Windows.ATOM;
  
  VAR
      MainWindowClassData : Windows.WNDCLASS;
      MainWindowClassAtom : Windows.ATOM;
  
  VAR
      MessageWindowClassData : Windows.WNDCLASS;
      MessageWindowClassAtom : Windows.ATOM;
  
  VAR
      StatusWindowClassData : Windows.WNDCLASS;
      StatusWindowClassAtom : Windows.ATOM;
  
  
  PROCEDURE AllocateMoriaClassData (instance : Windows.HINSTANCE);
    PROCEDURE AllocateDungeonWindowClassData (instance : Windows.HINSTANCE);
    BEGIN (* AllocateDungeonWindowClassData *)
      WITH DungeonWindowClassData DO
        hbrBackground := Windows.COLOR_WINDOW + 1;
        lpszClassName := SYSTEM.ADR (MStruct.DungeonWindowClassName);
        lpszMenuName  := Windows.LP_NULL;
        lpfnWndProc   := MDWindow.DungeonWindowTranslator;
        cbClsExtra    := 0;
        cbWndExtra    := 0;
        hInstance     := instance;
        hCursor       := WCursor.StandardCursorHandle (Windows.IDC_ARROW);
        hIcon         := Windows.NULL;
        style         := Windows.CS_HREDRAW + Windows.CS_VREDRAW + Windows.CS_NOCLOSE;
      END; (* WITH *)
      
      WCreation.RegisterClass (DungeonWindowClassData,DungeonWindowClassAtom);
    END AllocateDungeonWindowClassData;
    
    PROCEDURE AllocateMainWindowClassData (instance : Windows.HINSTANCE);
    BEGIN (* AllocateMainWindowClassData *)
      WITH MainWindowClassData DO
        hbrBackground := WDTool.GetStockObject (Windows.BLACK_BRUSH);
        lpszClassName := SYSTEM.ADR (MainWindowClassName);
        lpszMenuName  := SYSTEM.ADR ("Main_Menu");
        lpfnWndProc   := MMTranslator.MainWindowTranslator;
        cbClsExtra    := 0;
        cbWndExtra    := 0;
        hInstance     := instance;
        hCursor       := WCursor.StandardCursorHandle (Windows.IDC_ARROW);
        style         := Windows.CS_HREDRAW + Windows.CS_VREDRAW + Windows.CS_BYTEALIGNWINDOW;
        
        WResource.LoadIcon (instance,"Program_Icon",hIcon);
      END; (* WITH *)
      
      WCreation.RegisterClass (MainWindowClassData,MainWindowClassAtom);
    END AllocateMainWindowClassData;
    
    PROCEDURE AllocateMessageWindowClassData (instance : Windows.HINSTANCE);
    BEGIN (* AllocateMessageWindowClassData *)
      WITH MessageWindowClassData DO
        hbrBackground := Windows.COLOR_WINDOW + 1;
        lpszClassName := SYSTEM.ADR (MStruct.MessageWindowClassName);
        lpszMenuName  := Windows.LP_NULL;
        lpfnWndProc   := MMWindow.MessageWindowTranslator;
        cbClsExtra    := 0;
        cbWndExtra    := 0;
        hInstance     := instance;
        hCursor       := WCursor.StandardCursorHandle (Windows.IDC_ARROW);
        hIcon         := Windows.NULL;
        style         := Windows.CS_HREDRAW + Windows.CS_VREDRAW + Windows.CS_NOCLOSE;
      END; (* WITH *)
      
      WCreation.RegisterClass (MessageWindowClassData,MessageWindowClassAtom);
    END AllocateMessageWindowClassData;
    
    PROCEDURE AllocateStatusWindowClassData (instance : Windows.HINSTANCE);
    BEGIN (* AllocateStatusWindowClassData *)
      WITH StatusWindowClassData DO
        hbrBackground := Windows.COLOR_WINDOW + 1;
        lpszClassName := SYSTEM.ADR (MStruct.StatusWindowClassName);
        lpszMenuName  := Windows.LP_NULL;
        lpfnWndProc   := MSWindow.StatusWindowTranslator;
        cbClsExtra    := 0;
        cbWndExtra    := 0;
        hInstance     := instance;
        hCursor       := WCursor.StandardCursorHandle (Windows.IDC_ARROW);
        hIcon         := Windows.NULL;
        style         := Windows.CS_HREDRAW + Windows.CS_VREDRAW + Windows.CS_NOCLOSE;
      END; (* WITH *)
      
      WCreation.RegisterClass (StatusWindowClassData,StatusWindowClassAtom);
    END AllocateStatusWindowClassData;
    
  BEGIN (* AllocateMoriaClassData *)
    AllocateMainWindowClassData (instance);
    
    AllocateDungeonWindowClassData (instance);
    AllocateMessageWindowClassData (instance);
    AllocateStatusWindowClassData (instance);
  END AllocateMoriaClassData;
END MWClasses.
