IMPLEMENTATION MODULE MWDepth;
  (*/WIN:A*)
  
  IMPORT WDialog,WError,Windows;
  IMPORT MStruct;
  
  
  CONST
        DepthEditTextControl = 702;
  
  CONST
        DepthAcceptPushButtonControl = 703;
        DepthCancelPushButtonControl = 704;
  
  
  PROCEDURE CloseDepthChangeDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* CloseDepthChangeDialog *)
    ExecuteDepthCancelButton (window,Windows.BN_CLICKED);
  END CloseDepthChangeDialog;
  
  PROCEDURE ExecuteDepthCancelButton (window : Windows.HWND; command : CARDINAL);
  BEGIN (* ExecuteDepthCancelButton *)
    IF command = Windows.BN_CLICKED THEN
      WDialog.EndDialog (window,MIN (INTEGER));
    END; (* IF *)
  END ExecuteDepthCancelButton;
  
  PROCEDURE ExecuteDepthChangeCommand (window : Windows.HWND; player : MStruct.PlayerInfoPointer; control : CARDINAL; command : CARDINAL);
    PROCEDURE ExecuteAcceptButton (window : Windows.HWND; command : CARDINAL);
      VAR
          depth : CARDINAL;
          done  : BOOLEAN;
      
    BEGIN (* ExecuteAcceptButton *)
      IF command = Windows.BN_CLICKED THEN
        WDialog.GetDlgItemCardinal (window,DepthEditTextControl,depth,done);
        
        IF (done AND (depth >= 0) AND (depth <= 99)) THEN
          WDialog.EndDialog (window,depth);
        ELSE
          WError.DisplayInformationBox (window,MStruct.MainWindowTitle,"Invalid depth value.");
        END; (* IF *)
      END; (* IF *)
    END ExecuteAcceptButton;
    
  BEGIN (* ExecuteDepthChangeCommand *)
    CASE control OF
      DepthCancelPushButtonControl,Windows.IDCANCEL : ExecuteDepthCancelButton (window,command); |
      DepthAcceptPushButtonControl,Windows.IDOK     : ExecuteAcceptButton (window,command);      |
    ELSE
      (* no action *)
    END; (* CASE *)
  END ExecuteDepthChangeCommand;
  
  PROCEDURE InitializeDepthChangeDialog (window : Windows.HWND; player : MStruct.PlayerInfoPointer);
  BEGIN (* InitializeDepthChangeDialog *)
    (* no action *)
  END InitializeDepthChangeDialog;
END MWDepth.
